<template>
  <background class="row justify-center">
    <q-table
      class="col-lg-6 col-md-8 col-sm-12 col-xs-12"
      title="Administrace uživatelů"
      :rows="rows"
      :columns="columns"
      row-key="name"
      :pagination="initialPagination"
      :loading="loadingForm"
    >
      <template #body="props">
        <q-tr :props="props">
          <q-td
            key="name"
            :props="props"
          >
            {{ props.row.name }}
            <q-popup-edit
              v-slot="scope"
              v-model="props.row.name"
              buttons
              :validate="validateName"
            >
              <q-input
                v-model="scope.value"
                type="text"
                dense
                autofocus
                :error="errorName"
                :error-message="errorNameMessage"
                @keyup.enter="scope.set"
              />
            </q-popup-edit>
          </q-td>

          <q-td
            key="role"
            :props="props"
          >
            <q-select
              v-model="props.row.role"
              :options="roleTranslatedSelect"
              map-options
              emit-value
              options-dense
            />
          </q-td>

          <q-td
            key="actions"
            :props="props"
          >
            <q-btn
              color="negative"
              label="Smazat"
              :disable="loadingDelete"
              :loading="loadingDelete"
              @click="onUserDelete(props.row.id)"
            >
              <template #loading>
                <q-spinner-gears />
              </template>
            </q-btn>
          </q-td>
        </q-tr>
      </template>

      <template #loading>
        <q-inner-loading
          showing
          color="primary"
        />
      </template>
    </q-table>
  </background>
</template>

<script lang="ts">
import { ref } from '@vue/reactivity'
import { watch } from '@vue/runtime-core'
import _ from 'lodash'
import { Notify } from 'quasar'
import { UserModel } from 'web_trains_types'

import background from '@/components/Background.vue'
import { roleTranslatedSelect } from '@/config/roleTranslator'
import { userService } from '@/service'

const columns = [
  {
    name: 'name',
    field: 'name',
    label: 'Jméno',
    required: true,
    align: 'left',
    sortable: true
  },
  {
    name: 'role',
    field: 'role',
    label: 'Role',
    required: true,
    sortable: true
  },
  {
    name: 'actions',
    label: 'Akce',
    required: true
  }
]

const initialPagination = {
  sortBy: 'name',
  descending: false,
  page: 1,
  rowsPerPage: 10
}

export default {
  name: 'AdminUser',
  components: {
    background
  },
  setup (): any {
    const loadingForm = ref(true)
    const loadingDelete = ref(false)
    const rows = ref<UserModel[]>()

    const stopLoading = () => { loadingForm.value = false }

    const notifySuccess = () => {
      Notify.create({
        message: 'Změna problěhla úspěšně',
        type: 'positive'
      })
    }

    const handleChange = (newVal: UserModel, oldVal: any) => {
      loadingForm.value = true
      const patch: any = {}
      for (const [key, value] of Object.entries(newVal)) {
        if (value !== oldVal[key]) {
          patch[key] = value
        }
      }

      userService.patchUser(patch, newVal.id)
        .then(notifySuccess)
        .finally(stopLoading)
    }

    userService.getAll()
      .then((users) => {
        rows.value = users

        rows.value.forEach((val) => {
          watch(() => _.clone(val), handleChange)
        })
      })
      .finally(stopLoading)

    const onUserDelete = (userId: number) => {
      loadingForm.value = true

      userService.delete(userId)
        .then(() => {
          if (rows.value === undefined) {
            return
          }

          _.remove(rows.value, (obj) => obj.id === userId)

          notifySuccess()
        })
        .finally(stopLoading)
    }

    const errorName = ref(false)
    const errorNameMessage = ref('')

    const validateName = (val: string) => {
      if (val.length < 1) {
        errorName.value = true
        errorNameMessage.value = 'Prosím zadejte jméno'
        return false
      }

      if (val.length > 255) {
        errorName.value = true
        errorNameMessage.value = 'Jméno je příliš dlouhé'
        return false
      }

      errorName.value = false
      errorNameMessage.value = ''
      return true
    }

    return {
      initialPagination,
      columns,
      rows,
      loadingForm,
      loadingDelete,
      onUserDelete,
      roleTranslatedSelect,
      validateName,
      errorName,
      errorNameMessage
    }
  }
}

</script>
